<template>
  <div id="app">
    <!-- <img src="./assets/logo.png"> -->
    <div class="control">
      <div class="box is-pulled-left" style="width:20%">
        <form>
          <div class="field">
            <label class="label">Descripción</label>
            <div class="control">
              <input type="text" class="input is-small" v-model="description">
            </div>
            <p class="help">Introduzca una descripción breve del producto</p>
          </div>
          <div class="field">
            <label class="label">Cantidad</label>
            <div class="control">
              <input type="text" class="input is-small" style="width:20%" v-model="quantity">
            </div>
            <p class="help">Introduzca la cantidad</p>
          </div>
          <div class="field is-grouped is-grouped-right">
            <p class="control">
              <button class="button is-small is-danger is-outlined" @click="clear">
                Limpiar
              </button>
            </p>
            <p class="control">
              <button class="button is-small is-primary" @click="send">
                Enviar
              </button>
            </p>
          </div>
        </form>
        {{ data }}
        {{ hoodieDataCh }}
      </div>
    </div>
    <div class="control">
      <nav class="panel is-pulled-left" style="width:30%">
        <p class="panel-heading">
          texto
        </p>
        <div class="panel-block" :key="item._id" v-for="item in hoodieData">
          <div class="control">
            <div class="field is-grouped">
              <div class="control is-expanded">
                <label class="label is-fullwidth">
                  {{ item.description }}
                </label>
              </div>
              <div class="control">
                <label class="label">
                  {{ item.quantity }}
                </label>
              </div>
            </div>
          </div>
        </div>
      </nav>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'
import hoodie from '../.hoodie/client.js'

export default {
  name: 'app',
  data () {
    return {
      description: '',
      quantity: 0,
      hoodieData: []
    }
  },
  created () {
    this.list()
    hoodie.store.on('change', this.list)
    hoodie.store.on('clear', function () {
      this.refreshHoodieData([])
    })
  },
  computed: {
    data () {
      return JSON.stringify({
        description: this.description,
        quantity: this.quantity
      })
    },
    hoodieDataCh () {
      return this.hoodieData
    }
  },
  methods: {
    getNextID () {
      return _.isEmpty(this.hoodieData) ? '1' : (Number(this.hoodieData[this.hoodieData.length - 1]._id) + 1).toString()
    },
    refreshHoodieData (newHoodieData) {
      this.hoodieData.splice(0, this.hoodieData.length)
      newHoodieData.forEach((data) => {
        this.hoodieData.push(data)
      })
      console.log(this.hoodieData)
    },
    list () {
      hoodie.store.findAll()
      .then((response) => {
        let orderedList = _.orderBy(response, ['_id'], ['asc'])
        console.log(JSON.stringify(orderedList))
        this.refreshHoodieData(orderedList)
      })
    },
    send () {
      let d = new Date()
      console.log(`Enviado todo a las ${d.getHours()}:${d.getMinutes()}:${d.getSeconds()}`)

      hoodie.store.add({
        _id: this.getNextID(),
        description: this.description,
        quantity: this.quantity
      })
    },
    clear () {
      hoodie.store.removeAll()
    }
  }
}
</script>

<style>
#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  /* text-align: center; */
  color: #2c3e50;
  margin-top: 60px;
}
</style>
